<template>
  <div>
    <div class="h1 mb-4">
      <div class="float-right">
        <b-button @click="newModal" variant="info">
          <font-awesome-icon :icon="['fas', 'plus']" class="mr-2" /> Add Brick
        </b-button>
      </div>

      Editing: {{ templateName }}
      <TemplateTypeBadge :type="templateType"></TemplateTypeBadge>
    </div>

    <div class="row">
      <div class="col-6">
        <b-input
          v-model="textFilter"
          @change="refreshData"
          placeholder="Search (use % as wildcard, press ENTER to submit)"
        ></b-input>
      </div>
    </div>

    <div class="mt-4">
      <div class="row mt-2 pt-1 pb-1 font-weight-bold">
        <div class="col-5 pl-5">Key</div>
        <div class="col-3">Hint</div>
        <div class="col-2">Placeholders</div>
        <div class="col-1">Type</div>
        <div class="col-1">Multiline</div>
      </div>
      <div
        v-for="brick in bricks"
        :class="{ 'row-color-deleted': brick.deleted }"
        :key="brick.key"
        class="row striped to-stripe mt-2 pt-1 pb-1"
      >
        <div class="col-5">
          <b-button
            :disabled="brick.deleted"
            @click="editModal(brick)"
            variant="success"
            class="mr-2"
            size="sm"
          >
            <font-awesome-icon :icon="['fas', 'pencil-alt']" />
          </b-button>
          <b-button
            :disabled="brick.deleted"
            @click="askDelete(brick)"
            variant="danger"
            class="mr-2"
            size="sm"
          >
            <font-awesome-icon :icon="['fas', 'trash']" />
          </b-button>
          {{ brick.key }}
        </div>
        <div class="col-3">
          <div
            style="overflow: hidden;white-space: nowrap;text-overflow: ellipsis;"
          >
            {{ brick.translationHint }}
          </div>
        </div>
        <div class="col-2">
          <b-badge
            v-for="placeholder in brick.placeholders"
            :key="placeholder"
            class="m-1"
            >{{ placeholder }}</b-badge
          >
        </div>
        <div class="col-1">
          <BrickTypeBadge :type="brick.type"></BrickTypeBadge>
        </div>
        <div class="col-1"><span v-if="brick.multiline">multiline</span></div>
      </div>
    </div>

    <BrickDefinitionModal
      ref="modal"
      :default-language="template.defaultLanguage"
      @save="onSave"
    ></BrickDefinitionModal>
  </div>
</template>

<script>
import BrickDefinitionModal from './brick/BrickDefinitionModal';
import TemplateTypeBadge from './badge/TemplateTypeBadge';
import BrickTypeBadge from './badge/BrickTypeBadge';

export default {
  components: {
    BrickTypeBadge,
    TemplateTypeBadge,
    BrickDefinitionModal,
  },
  props: {
    apiBaseUrl: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      template: { name: this.$route.params.id, type: 'loading' },
      textFilter: '',
      currentPage: 0,
      pageSize: 999999,
      totalPages: 0,
      bricks: [],
    };
  },
  computed: {
    templateName() {
      return this.template.name;
    },
    templateType() {
      return this.template.type;
    },
  },
  mounted() {
    this._loadTemplate();
    this.refreshData();
  },
  methods: {
    refreshData() {
      this._loadData();
    },
    async _loadTemplate() {
      this.template = await this.$axios
        .$get(`${this.apiBaseUrl}/translator/template/${this.$route.params.id}`)
        .catch((err) => {
          alert(err);
        });
    },
    async _loadData() {
      const loader = this.$loading.show();

      const result = await this.$axios
        .$get(
          `${this.apiBaseUrl}/admin/brick/${this.$route.params.id}?pageNumber=${
            this.currentPage
          }&pageSize=${this.pageSize}&searchTerm=${encodeURIComponent(
            this.textFilter
          )}`
        )
        .catch((err) => {
          alert(err);
        });

      this.bricks = result.content;
      this.totalPages = result.totalPages;

      loader.hide();
    },
    newModal() {
      this.$refs.modal.show();
    },
    editModal(brick) {
      this.$refs.modal.show(brick);
    },
    async onSave(brick, form, createAnother) {
      const request = {
        template: this.$route.params.id,
        key: form.key,
        type: form.type,
        multiline: !!form.multiline, // prevent setting it to undefined
        translationHint: form.translationHint,
        placeholders: form.placeholders,
      };

      this.$refs.modal.hide();

      const loader = this.$loading.show();

      if (brick === null) {
        await this.$axios
          .$post(`${this.apiBaseUrl}/admin/brick`, request)
          .catch((err) => {
            alert(err);
          });

        this.refreshData();
      } else {
        await this.$axios
          .$put(`${this.apiBaseUrl}/admin/brick`, request)
          .catch((err) => {
            alert(err);
          });

        this.bricks.forEach((elem) => {
          if (elem.key === brick.key) {
            elem.type = request.type;
            elem.multiline = request.multiline;
            elem.placeholders = request.placeholders;
            elem.translationHint = request.translationHint;
          }
        });
      }

      if (form.initialTranslation && form.initialTranslation !== '') {
        const request2 = {
          key: form.key,
          lang: this.template.defaultLanguage,
          template: this.template.id,
          value: form.initialTranslation,
        };

        await this.$axios
          .$put(`${this.apiBaseUrl}/translator/translation`, request2)
          .catch((err) => {
            alert(err);
          });
      }

      loader.hide();

      if (createAnother) {
        this.$refs.modal.show();
      }
    },
    askDelete(brick) {
      this.$bvModal
        .msgBoxConfirm('Are you sure?', { centered: true })
        .then((value) => {
          if (value === true) {
            this.doDelete(brick);
          }
        })
        // eslint-disable-next-line handle-callback-err
        .catch((err) => {
          // An error occurred
        });
    },
    async doDelete(brick) {
      await this.$axios
        .$delete(
          `${this.apiBaseUrl}/admin/brick/${brick.template}/${brick.key}`
        )
        .catch((err) => {
          alert(err);
        });
    },
  },
};
</script>
